﻿# Sici Spawn release 1.1 by Sicilia
# -*- coding:Utf-8 -*-
# ./addons/eventscripts/sici_spawn/sici_spawn.py

# >>> To configure this addon please see sici_spawn.cfg <<<

#################################
#### DO NOT EDIT THIS FILE, #####
####    IF YOU DO, THINGS   #####
####   THINGS COULD BREAK   #####
#################################

import es, gamethread, playerlib, cfglib

config = cfglib.AddonCFG(es.getAddonPath("sici_spawn") + "/sici_spawn.cfg")
 
config.text("******************************")
config.text("******************************")
config.text("  Sici Spawn SETTINGS")
config.text("******************************")
config.text("******************************")
 
sici_spawn_enable     = config.cvar("sici_spawn_enable",     1, "Enable/disable Sicilia's sici_spawn")

config.text("")
config.text("******************************")
config.text("  Respawn SETTINGS")
config.text("******************************")

sici_spawn_respawn   = config.cvar("sici_spawn_respawn",   1, "Enable/disable sici_spawn respawn module.")
sici_spawn_timerespawn   = config.cvar("sici_spawn_timerespawn",   0.25, "Time for respawn default: 0.25")

config.text("")
config.text("******************************")
config.text("  Delete Body SETTINGS")
config.text("******************************")

sici_spawn_deletebody   = config.cvar("sici_spawn_deletebody",   1, "Enable/disable sici_spawn deleteBody module.")

config.text("")
config.text("******************************")
config.text("  Anti Spawn Kill SETTINGS")
config.text("******************************")

sici_spawn_antispawnkill   = config.cvar("sici_spawn_antispawnkill",   1, "Enable/disable sici_spawn antispawnkill module.")
sici_spawn_timeantispawnkill   = config.cvar("sici_spawn_timeantispawnkill",   5, "Time in sec for antispawn kill default: 5")

config.text("")
config.text("******************************")
config.text("  NoBlock SETTINGS")
config.text("******************************")

sici_spawn_noblock   = config.cvar("sici_spawn_noblock",   1, "Enable/disable sici_spawn noblock module.")

config.write() # Writes the .cfg to file
 
 
info = es.AddonInfo()
info.version = "1.1p1"
info.author = "Sicilia"
info.name = "sici_spawn"
info.url = "http://addons.eventscripts.com/addons/user/22862"
info.date = "27.04.2011"
info.sponsor = "fog.asso.fr"

es.ServerVar('Sici Spawn', info.version, 'Script By Sicilia').makepublic()
 
def load():
	es.msg("[Sici Spawn Loaded]")
	es.mexec("../addons/eventscripts/sici_spawn/sici_spawn.cfg")
	
def unload():
	es.msg("[Sici Spawn Unloaded]")
	
def es_map_start(E):
	es.mexec("../addons/eventscripts/sici_spawn/sici_spawn.cfg")

def player_death(E):
	if sici_spawn_enable:
		if sici_spawn_respawn:
			if es.getplayerteam(E['userid']) > 1:
				gamethread.cancelDelayed("resp_%s" % E["userid"])
				gamethread.delayedname(int(sici_spawn_timerespawn), "resp_%s" % E["userid"], respawn, E["userid"])
				
		if sici_spawn_deletebody:
			user_handle = es.getplayerhandle(E["userid"])
			for ragdoll_index in es.createentitylist("cs_ragdoll"):
				if (es.getindexprop(ragdoll_index, "CCSRagdoll.m_hPlayer") != user_handle):
					continue
				es.remove(ragdoll_index)
				
		if sici_spawn_antispawnkill:
			playerlib.getPlayer(E["userid"]).set('color', [255, 255, 255, 255])

def player_team(E):
    if sici_spawn_enable:    
		if sici_spawn_respawn:	
			if E["team"] > "1":
				gamethread.cancelDelayed("resp_%s" % E["userid"])
				gamethread.delayedname(int(sici_spawn_timerespawn), "resp_%s" % E["userid"], respawn, E["userid"])
				
		if sici_spawn_deletebody:
			user_handle = es.getplayerhandle(E["userid"])
			for ragdoll_index in es.createentitylist("cs_ragdoll"):
				if (es.getindexprop(ragdoll_index, "CCSRagdoll.m_hPlayer") != user_handle):
					continue
				es.remove(ragdoll_index)        
    
def player_say(E):
    if sici_spawn_enable:  
		if sici_spawn_respawn:
			if E["text"] in ['!respawn', '!rsp']:
				if E["es_userteam"] > "1":
					if es.getplayerprop(E["userid"], "CBasePlayer.pl.deadflag"):
						respawn(E["userid"])
					else: es.tell(E["userid"], "You can't use this command\nThis command is only for a player death.")                

def player_spawn(E):               
    if sici_spawn_enable:    
		userid = int(E["userid"])
		if sici_spawn_antispawnkill:
			joueur = playerlib.getPlayer(userid)
			couleur = joueur.get('color')
			es.setplayerprop(userid, "CBasePlayer.m_lifeState", 0)	
			if es.getplayerteam(userid) == 3:
				joueur.set('color', [0, 0, 255, 128])
			elif es.getplayerteam(userid) == 2:
				joueur.set('color', [255, 0, 0, 128])
			gamethread.cancelDelayed("echo_%s" % userid)	
			gamethread.delayedname(int(sici_spawn_timeantispawnkill), "echo_%s" % userid, reset, (userid, couleur))
				
		if sici_spawn_noblock:
			es.setplayerprop(userid, "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup", 2)

def respawn(U):
    es.setplayerprop(U, "CCSPlayer.m_iPlayerState", 0)
    es.server.queuecmd('es_xspawnplayer %s' % U)
	
def reset(userid, couleur):
	es.setplayerprop(userid, "CBasePlayer.m_lifeState", 512)
	playerlib.getPlayer(userid).set('color', couleur)
